/********************************************************************
*  $B%?%V%l%C%H$K$h$k<~GH?tFC@-B,Dj(B
*  PIC16F1829 $B$r;HMQ$7!"(BBluetooth$B$GDL?.(B
*  $B@589GH=PNO!'(BAD5932$B!!(BSPI$B@\B3(B
*  $B%m%0%"%s%W!'(BAD8310$B!!(BAN6$B$G%"%J%m%0F~NO(B
********************************************************************/
#include <htc.h>
/***** $B%3%s%U%#%.%e%l!<%7%g%s$N@_Dj(B *********/
// CONFIG1
#pragma config FOSC = INTOSC        // $BFbB"%/%m%C%/(B
#pragma config WDTE = OFF           // WDT $B6X;_(B
#pragma config PWRTE = ON           // PWRT $BM-8z(B
#pragma config MCLRE = ON           // MCLR$BM-8z(B
#pragma config CP = OFF             // $B%W%m%F%/%H$J$7(B
#pragma config CPD = OFF            // $B%W%m%F%/%H$J$7(B
#pragma config BOREN = ON           // BOR$BM-8z(B
#pragma config CLKOUTEN = OFF       // $B%/%m%C%/=PNO$J$7(B
#pragma config IESO = OFF           // $B%/%m%C%/@Z$jBX$($J$7(B
#pragma config FCMEN = OFF          // $B%/%m%C%/4F;k$J$7(B
// CONFIG2
#pragma config WRT = OFF            // $B%U%i%C%7%e=q$-9~$_6X;_$J$7(B
#pragma config PLLEN = ON           // PLL$BM-8z(B
#pragma config STVREN = OFF         // $B%9%?%C%/%*!<%P!<%U%m!<%j%;%C%HL58z(B
#pragma config BORV = LO            // BOR$BEE05(BLow
#pragma config LVP = OFF            // $BDcEE05=q$-9~$_6X;_(B
/***** DDS$BMQ%T%s;XDj(B ******/
#define ddsFSYN     LATCbits.LATC6
#define ddsSCLK     LATCbits.LATC3
#define ddsSDAT     LATAbits.LATA4
#define ddsCTRL     LATAbits.LATA5
#define RedLED      LATBbits.LATB6
#define GreenLED    LATBbits.LATB4
/* Bluetooth$B%b%8%e!<%k@_DjMQ%3%^%s%I%G!<%?(B */
unsigned char msg1[] = "$$$";                // $B%3%^%s%I%b!<%I;XDj(B
unsigned char msg2[] = "SF,1\r";            // $B=i4|2=(B
unsigned char msg3[] = "SN,Analyzer\r";     // $B;XDj(B
unsigned char msg4[] = "R,1\r";             // $B:F5/F0(B
/**** $BJQ?tDj5A!!(B***/
union{
    unsigned long Freq;                     // DDS$BMQ<~GH?t(B
    unsigned int  iFreq[2];
    unsigned char cFreq[4];
}ddsFreq;
unsigned long oldFreq;
unsigned char State, Flag;
unsigned char RcvBuf[64];                   // Bluetooth$B<u?.%P%C%U%!(B
unsigned char SndBuf[64];                   // Bluetooth$BAw?.%P%C%U%!(B
int Index, i, j;
/** $B4X?t%W%m%H%?%$%T%s%0(B */
void Send(unsigned char Data);
void setFreq(long freq);
void spi_send(unsigned int data);
void Delayms( unsigned int t);
void Process(void);
void SendStr(unsigned char * str);
void SendCmd(unsigned char *cmd);

/************ $B%a%$%s4X?t(B ********************/
void main(void){
    /** $B%/%m%C%/@_Dj(B **/
    OSCCON = 0xF0;                      // $BFbB"(B8MHz$B!!(BPLL On 32MHz
    /* $BF~=PNO%]!<%H@_Dj(B  */
    ddsFSYN = 1;
    ddsCTRL = 1;
    /* $BF~=PNO%]!<%H$N@_Dj(B */
    APFCON0 = 0x84;                     // RX=RC5, TX=RC4    
    ANSELA = 0x00;                      // $B$9$Y$F%G%8%?%k%T%s(B
    ANSELB = 0x00;                      // $B$9$Y$F%G%8%?%k%T%s(B
    ANSELC = 0x04;                      // RC2(AN6)$B$N$_%"%J%m%0F~NO(B
    TRISA  = 0x0F;                      // 
    TRISB  = 0x00;                      // $B=PNO(B
    TRISC  = 0x24;                      // RC4,5(RX),RC2(AN6)$B$N$_F~NO(B
    WPUA   = 0x04;                      // RA2$B$N$_(Bpullup
    OPTION_REGbits.nWPUEN = 0;          // Pullup Enable
    /* BT$B%b%8%e!<%k$N%j%;%C%H(B */
    LATCbits.LATC1 = 0;
    Delayms(200);
    LATCbits.LATC1 = 1;
    /* USART$B$N=i4|@_Dj(B */
    TXSTA = 0x24;                       // TXSTA,$BAw?.%b!<%I@_Dj(B BRGH=1
    RCSTA = 0x90;                       // RCSTA,$B<u?.%b!<%I@_Dj(B
    BAUDCON=0x08;                       // BAUDCON$B!!(B16bit
    SPBRGH = 0;
    SPBRGL = 68;                        // SPBRG,$BDL?.B.EY@_Dj(B(115.2kbps)
    PIR1bits.RCIF = 0;                  // $B3d$j9~$_%U%i%0%/%j%"(B
    PIE1bits.RCIE = 1;                  // $B3d$j9~$_5v2D(B
    /* ADC$B$N=i4|@_Dj(B */
    ADCON0 = 0;                         // ADC$BL58z2=(B
    ADCON1 = 0xA0;			// $B1&5M$a!"%j%U%!%l%s%9@_Dj!!(BFosc/32 $BB.EY@_Dj(B
    /** DDS$B$N=i4|@_Dj!!(B**/
    ddsFreq.Freq = 1000;		// $B=i4|CM(B1kHz
    oldFreq = 0;
    spi_send(0x07FF);			// $B@)8f%3%^%s%IAw?.(B
    spi_send(0x1000);			// $B%$%s%/%j%a%s%H?t$J$7(B
    spi_send(0x2000);			// $B&$(Bf$B$J$7(B
    spi_send(0x3000);			// $B&$(Bf$B$J$7(B
    spi_send(0x4000);			// $B%$%s%?!<%P%k$J$7(B
    setFreq(1000);			// $B=i4|CM(B1kHz
    Index = 0;
    Flag = 0;
    State = 0;
    /* $B3d$j9~$_5v2D(B**/
    INTCONbits.PEIE = 1;
    INTCONbits.GIE = 1;

    /*********** $B%a%$%s%k!<%W(B ***************/
    while(1)  {
       switch(State){
            case 0:
                /** Bluetooth$B%b%8%e!<%k=i4|2=(B */
                if(PORTAbits.RA2 == 0){             // S1$B$,2!$5$l$F$$$k>l9g(B
                    Delayms(1000);                   
                    SendCmd(msg1);                  //$$$
                    Delayms(1000);
                    SendCmd(msg2);                  // $B%U%!%/%H%j%j%;%C%H(B
                    SendCmd(msg3);                  // $BL>>N@_Dj(B
                    SendCmd(msg4);                  // $B%j%V!<%H(B
                }
                State = 1;                          //$B<!$X(B
                break;
            case 1:
                Delayms(1000);                      // $B@\B3BT$ACY1d(B
                Index = 0;                          // $B%P%C%U%!%$%s%G%C%/%9=i4|2=(B
                State = 2;
                break;
            case 2:
                /* $B<u?.%3%^%s%I=hM}%k!<%W(B */
                if((Flag == 1) && (RcvBuf[0] == 'S')) {
                    RedLED ^= 1;
                    SndBuf[0] = 'M';                // $BJV?.%^!<%/J]B8(B
                    SndBuf[1] = RcvBuf[1];          // $BJV?.6hJLJ]B8(B
                    Process();                      // $B%3%^%s%I=hM}<B9T(B
                    Index = 0;                      // $B%P%C%U%!%]%$%s%?=i4|2=(B
                    Flag = 0;                       // $B<u?.40N;%U%i%0%/%j%"(B
                }
                break;
            default:
                break;
        }
    }
}

/**************************************************
*  $B%G!<%?<u?.=hM}4X?t(B
*  $B%G!<%?$O(BRcvBuf[]$BFb(B 
***************************************************/
void Process(void){ 

    /******** $B<u?.%3%^%s%I$4$H$N=hM}(B ********/
    switch(RcvBuf[1]){                                   // $B%3%^%s%I%3!<%I%A%'%C%/(B
        unsigned int temp;
        /** $B%G!<%?7WB,3+;O%H%j%,(B ***/
        case 'T':
            SndBuf[2] = 'O';
            SndBuf[3] = 'K';
            SndBuf[4] = 'E';
            SendStr(SndBuf);
            break;
        /** $B<~GH?t@_Dj$H%l%Y%kB,DjCMJVAw(B */
        case 'N':
            /** $B<~GH?t@_DjCM<hF@$H@_Dj@)8f(B **/
            for(i=0; i<4; i++)
                ddsFreq.cFreq[i] = RcvBuf[i+2];         // $B%P%$%H$+$i?tCM$XJQ49(B
            if(ddsFreq.Freq != oldFreq)                 // $BF1$8<~GH?t$J$i2?$b$7$J$$(B
                setFreq(ddsFreq.Freq);                  // $B0[$J$k<~GH?t$J$i@_Dj=PNO<B9T(B
            oldFreq = ddsFreq.Freq;                     // $B5l<~GH?t%G!<%?$r99?7(B
            /* $B7WB,CM0BDj2=BT$A!!(B**/
            Delayms(100);                                // $BHoB,DjAuCV$N=PNO0BDjBT$A(B
            /* $B%l%Y%k7WB,%G!<%?JVAw(B */
            temp = 0;
            for(i=0; i<10; i++){                        // 10$B2s$NJ?6Q(B
                ADCON0 = 0x19;                          // $B%A%c%M%k(B6$BA*Br(B ADON
                ADCON0bits.GO = 1;                      // $BJQ493+;O(B
                while(ADCON0bits.GO);                   // $BJQ49=*N;BT$A(B
                temp = temp + ADRESH*256 + ADRESL;      // CH1$BB,Dj(B
                Delayms(2);                             // 2msec$B4V3V$G%5%s%W%j%s%0(B
            }
            SndBuf[2] = (temp/10) % 256;                // $BAw?.%P%C%U%!$K2<0L%;%C%H(B
            SndBuf[3] = (temp/10) / 256;                // $BAw?.%P%C%U%!$K>e0L%;%C%H(B
            SndBuf[4] = 'E';
            SendStr(SndBuf);
            break;
        /*** $BITL@(B ****/
        default:
            break;
    }     
}
/*************************************
* $B3d$j9~$_=hM}4X?t(B
* $B!!<u?.3d$j9~$_(B
*************************************/
void interrupt isr(void){
    unsigned char data;

    if(PIR1bits.RCIF){                              // $B<u?.3d$j9~$_$+!)(B
        PIR1bits.RCIF = 0;                          // $B<u?.3d$j9~$_%U%i%0%/%j%"(B
        if((RCSTAbits.OERR) || (RCSTAbits.FERR)){   // $B%(%i!<H/@8$7$?>l9g(B
            RCSTA = 0;                              // USART$BL58z2=(B
            RCSTA = 0x90;                           // USART$B:FM-8z2=(B
        }
        else{                                       // $B@5>o<u?.$N>l9g(B
            if((State > 1)&&(Index<64)){            //
                RcvBuf[Index++] = RCREG;            // $B%G!<%?<h$j=P$7(B
                if(Index >= 64)                     // 64$B%P%$%H<u?.40N;$+!)(B
                    Flag = 1;                       // $B<u?.40N;%U%i%0%*%s(B
            }
            else                                    // $B%3%^%s%I<B9TCf$GL5$$>l9g(B
                data = RCREG;                       // $BFI$_Ht$P$7$FL5;k(B
        }
    }
}
/********************************
 * USART $BAw?.<B9T%5%V4X?t(B
 ********************************/
void Send(unsigned char Data){
    while(!TXSTAbits.TRMT);             // $BAw?.%l%G%#!<BT$A(B
    TXREG = Data;                       // $BAw?.<B9T(B
}
/********************************
 * Blurtooth$BJ8;zNsAw?.4X?t(B
 *******************************/
void SendStr(unsigned char * str){
    GreenLED ^= 1;
    for(i= 0; i<64; i++)                // 64$B%P%$%HAw?.(B
        Send(*str++);                   // $BAw?.<B9T(B
}
/********************************
 * Bluetooth$B%3%^%s%IAw?.4X?t(B
 * $BCY1dA^F~8eLa$k(B
 ********************************/
void SendCmd(unsigned char *cmd){
    while(*cmd != 0)                    // $B=*C<$^$G7+$jJV$7Aw?.(B
        Send(*cmd++);                   // $BAw?.<B9T(B
    Delayms(1000);                      // $BJV?.%9%-%C%WMQCY1d(B
}
/****************************************************************
* AD5932 DDS$B@_Dj@)8f4X?t(B
*$B!!!!%"%I%l%9!!5!G=(B
*$B!!!!(B0000$B!!!!%3%s%H%m!<%k%3%^%s%I(B
*$B!!!!(B0001$B!!!!%$%s%/%j%a%s%H?t(B
*$B!!!!(B0010$B!!!!&$(Bf$B2<0L(B12$B%S%C%H(B
*$B!!!!(B0011$B!!!!&$(Bf$B>e0L(B12$B%S%C%H(B
*$B!!!!(B0100$B!!!!%$%s%/%j%a%s%H%$%s%?!<%P%k(B
*$B!!!!(B1100$B!!!!3+;O<~GH?t2<0L(B12$B%S%C%H(B
*$B!!!!(B1101$B!!!!3+;O<~GH?t>e0L(B12$B%S%C%H(B
*$B!!%3%s%H%m!<%k%3%^%s%I(B   0000 0111 1111 1111
*$B!!!!(BD11$B!!!!!!(B0$B$GFHN)!!(B1$B$GO"B3(B
*$B!!!!(BD10$B!!!!!!(B1$B$G(BDAC$B%$%M!<%V%k(B
*$B!!!!(BD9$B!!!!!!(B 1$B$G@589GH!!(B0$B$G;03QGH(B
*$B!!!!(BD8$B!!!!!!(B 1$B$G(BMSBOUT$B%$%M!<%V%k(B
*$B!!!!(BD7,D6$B!!!!M=Hw!!(B1$B$H$9$k(B
*$B!!!!(BD5$B!!!!!!(B 1$B$N$H$-(BCTRL$B%T%s$G%$%s%/%j%a%s%H(B
*$B!!!!(BD4 $B!!!!!!M=Hw!!(B1$B$H$9$k(B
*$B!!!!(BD3$B!!!!!!(B SYNCOUT$B=PNO>r7o(B1$B$G%9%-%c%sA4BN!"(B0$B$G%$%s%/%j%a%s%H$4$H(B
*$B!!!!(BD2$B!!!!!!(B 1$B$G(BSYNCOUT$B%$%M!<%V%k(B
*$B!!!!(BD1,D0$B!!!!M=Hw!!(B1$B$K%;%C%H(B
*  $B<~GH?t@_DjCM!!(B24$B%S%C%H(B
*      FFFFFF = 16777215
*$B!!!!!!(B1$B%S%C%HEv$?$j(B2.8610Hz@48MHz
*$B!!!!!!(B1Hz=FFFFFF/(48MHz) = 0.349525$B%S%C%H(B
******************************************************************/
void setFreq(long freq){
    float temp;
    union{
        unsigned long para;
        unsigned int ipara[2];
    }DDSpara;

    /* $B<~GH?t@_DjCM$KJQ49(B */
    temp = (0.3496 * (float)freq);			// $B@_DjCM$KJQ49(B
    DDSpara.para = (long)temp << 4;			// $B@0?t$K$7$F>e0L$r(B12$B%S%C%H$K$9$k(B
    /* DDS$B@)8f<B9T(B */
    ddsCTRL = 1;					// CTRL = 0
    spi_send(0x07FF);					// $B@)8f%3%^%s%IAw?.(B
    spi_send(0xC000 | ((DDSpara.ipara[0]>>4) & 0x0FFF));// $B<~GH?t2<0L(B12$B%S%C%HAw?.(B
    spi_send(0xD000 | (DDSpara.ipara[1] & 0x0FFF));	// $B<~GH?t>e0L(B12$B%S%C%HAw?.(B
    ddsCTRL = 0;
    ddsCTRL = 1;					// CTRL=1 $B<~GH?t=PNO3+;O(B
}

/**************************************************
* SPI $B$G(B16$B%S%C%HAw?.4X?t(B
**************************************************/
void spi_send(unsigned int data){
    unsigned int mask;

    ddsFSYN = 0;			// CS Low
    ddsSCLK = 1;			// SCK high
    mask = 0x8000;			// $B%S%C%H%^%9%/=i4|CM%;%C%H(B
    for(i=0; i<16; i++){		// 16$B%S%C%H7+$jJV$7(B
        if((data & mask) != 0)		// $B%S%C%H%A%'%C%/(B
            ddsSDAT = 1;                // 1$B$N>l9g(B
        else
            ddsSDAT = 0;		// 0$B$N>l9g(B
        ddsSCLK = 0;			// SCK Low
        ddsSCLK = 0;			// $B%Q%k%9I}3NJ](B        
        ddsSCLK = 1;			// SCK High$B$KLa$9(B
        mask = mask >>1;		// $B%S%C%H%^%9%/0\F0(B
    }
    ddsFSYN = 1;			// CS High
}
/***********************************************
* $B%?%$%^(B2$B$K$h$k(B1msec$BC10L$NCY1d4X?t(B Tcy=8MHz
***********************************************/
void Delayms( unsigned int t){
    PIR1bits.TMR2IF = 0;                // $B3d$j9~$_%U%i%0%/%j%"(B
    PR2 = 125;                          // 1msec$B@_Dj(B  125
    T2CON = 0x07;                       // $B%?%$%^(B2$B%9%?!<%H!!(B1/64
    while (t--) {                       // $B7+$jJV$72s?t(B
        while (!PIR1bits.TMR2IF);       // 1msec$BBT$A(B
        PIR1bits.TMR2IF = 0;            // $B3d$j9~$_%U%i%0%/%j%"(B
    }
}


